import { _undefined, _valit } from "./symbols";
import { MakeRequired, RSA, RSN } from "./utils";
import type { Path, Validate, ValidationResult } from "./validate";
export declare type Valitate<V, MaybeUndefined extends boolean> = {
    [_valit]?: never;
    [_undefined]?: MaybeUndefined;
} & Validate<V>;
export declare type Valit<V, Options extends RSA = RSN, MaybeUndefined extends boolean = false> = Valitate<V, MaybeUndefined> & ((options: Partial<Options>) => Valitate<V, MaybeUndefined>);
export declare function valit<Arg extends any[], Type, Options extends RSA = RSN, MaybeUndefined extends boolean = false>(name: string, fn: (...args: Arg) => (val: unknown, path: Path, options: Partial<Options>) => ValidationResult, handleOptions?: {
    [K in keyof Options]?: (val: Type, o: NonNullable<Options[K]>, options: MakeRequired<Options, K>) => boolean;
}, defaultOptions?: {
    [K in keyof Options]?: Options[K];
}): (...args: Arg) => Valit<Type, Options, MaybeUndefined>;
